package cn.net.communal.cpzshandset.service.presenter.impl.exchange.sheepEx;

import java.util.ArrayList;
import java.util.List;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.os.Message;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;
import cilico.tools.barcode.PhoneScanner;
import cn.net.communal.cpzshandset.R;
import cn.net.communal.cpzshandset.bean.ActivateBean;
import cn.net.communal.cpzshandset.bean.ConfigBean;
import cn.net.communal.cpzshandset.bean.ExchangeCargoBean;
import cn.net.communal.cpzshandset.bean.SingleLabelOptionBean;
import cn.net.communal.cpzshandset.common.config.Config;
import cn.net.communal.cpzshandset.common.config.HandsetOperation;
import cn.net.communal.cpzshandset.common.config.HandsetVersionConstant;
import cn.net.communal.cpzshandset.common.config.RequestConstant;
import cn.net.communal.cpzshandset.common.config.TConfig;
import cn.net.communal.cpzshandset.common.util.LogUtil;
import cn.net.communal.cpzshandset.common.util.NetWorkUtils;
import cn.net.communal.cpzshandset.common.util.StringUtils;
import cn.net.communal.cpzshandset.service.bll.ActivateBll;
import cn.net.communal.cpzshandset.service.bll.SheepDealerBll;
import cn.net.communal.cpzshandset.service.bll.ExchangeCargoBll;
import cn.net.communal.cpzshandset.service.bll.ProductBll;
import cn.net.communal.cpzshandset.service.bll.SingleLabelBll;
import cn.net.communal.cpzshandset.service.bll.UploadStatusBll;
import cn.net.communal.cpzshandset.service.bll.config.ConfigBll;
import cn.net.communal.cpzshandset.service.presenter.SingleLabelScannerConstact;
import cn.net.communal.cpzshandset.service.presenter.base.impl.SingleLabelScannerConstactImpl;
import cn.net.communal.cpzshandset.service.thread.ThreadPoolManager;
import cn.net.communal.cpzshandset.service.thread.ThreadReqTools;
import cn.net.communal.cpzshandset.service.thread.impl.common.CommonSubmitSingleActivateThread;
import cn.net.communal.cpzshandset.service.thread.impl.sheepEx.SheepExSubmitCargo;
import cn.net.communal.cpzshandset.ui.adapter.SingleLabelAdapter;
import cn.net.communal.cpzshandset.ui.dialog.TipsDialog;
import cn.net.communal.cpzshandset.ui.dialog.TipsDialog.DSure;
import cn.net.communal.cpzshandset.ui.weight.DialogUtils;
import cn.net.cpzslibs.prot.bean.res.ProtStatusResBean;
import cn.net.cpzslibs.prot.handset.bean.Product;
import cn.net.cpzslibs.prot.handset.bean.res.DealerBean;
import cn.net.handsetlib.utils.ReadDeviceIDUtil;

public class SheepExCargoSingleLSPresenter extends SingleLabelScannerConstactImpl {

	private final SingleLabelScannerConstact.View sView;
	private Context context;
	private SingleLabelBll labelBll;
	private SheepDealerBll dealerBll;
	private ExchangeCargoBll cargoBll;
	private ConfigBll configBll;
	private ExchangeCargoBean currentCargo;
	private SingleLabelAdapter adapter;
	private List<SingleLabelOptionBean> labels = new ArrayList<>();
	private int option_id;
	private int currentHansetVersion = HandsetVersionConstant.HANDSET_SHEEP_EXCHANGE_CARGO;
	private int option_type = HandsetOperation.OPERATION_EXCHANGE_CARGO_CONSTANT.getOption();
	private TextView tv_scanner_text_identify1, tv_scanner_text_identify2, tv_scanner_text_identify3,
			tv_scanner_text_identify4;
	private TipsDialog tipsDialog;
	private ProgressDialog bProgressDialog = null;
	private Handler mHandler = new Handler() {
		@Override
		public void handleMessage(Message msg) {
			switch (msg.what) {
			case PhoneScanner.BARCODE_READ:
			case PhoneScanner.BARCODE_ERR_LABEL: // 成功
				scannerSuccess(msg.obj.toString());
				break;
			case PhoneScanner.BARCODE_NOREAD:
				// 数据扫描失败
				if (checkViewAvailable()) {
					sView.showMsgToast("取消扫描", Toast.LENGTH_SHORT);
				}
				break;
			case RequestConstant.REQUEST_FAIL:
				//请求失败
				if (!checkViewAvailable())return;
				dismissProgress();
				sView.showMsgToast("请求失败！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT:
				//超时
				if (!checkViewAvailable())return;
				dismissProgress();
				sView.showMsgToast("请求超时！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PROT01_LOGIN_FAIL:
				//登录失败
				if (!checkViewAvailable())return;
				dismissProgress();
				String errorMsg = msg.obj.toString();
				int errorCode = msg.arg1;
				sView.showMsgToast(errorMsg + errorCode, Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_SUBMIT_EXCHANGE_CARGO_20029_FAIL:
				if (!checkViewAvailable())return;
				dismissProgress();
				sView.showMsgToast("提交调货信息失败", Toast.LENGTH_SHORT);
//				ProtStatusResBean resBean = (ProtStatusResBean) msg.obj;
				currentCargo = cargoBll.queryExchangeCargoById(currentCargo.getId());
				setLabelStatusData();
				break;
			case RequestConstant.PROT_SUBMIT_EXCHANGE_CARGO_20029_SUCCESS:
				if (!checkViewAvailable())return;
				dismissProgress();
				sView.showMsgToast("提交调货信息成功", Toast.LENGTH_SHORT);
				sView.finishPage();
				break;
			}

		}

	};

	@Override
	public void scannerSuccess(String str) {
		if (!checkViewAvailable())
			return;
		LogUtil.d(TConfig.Echo, "scannerRecuess：" + str);
//		sView.vibrate(100);
		super.scannerSuccess(str);
		if (StringUtils.isEmpty(str)) {
			sView.showMsgToast("扫描标签不能为空！", Toast.LENGTH_SHORT);
			return;
		}
		if (!StringUtils.isNumber(str)) {
			sView.showMsgToast("您所扫描的不是中国追溯的合法标签！", Toast.LENGTH_SHORT);
			return;
		}
		if (!(str.length() == 16)) {
			sView.showMsgToast("您所扫描的不是中国追溯的合法标签！"+ str.length(), Toast.LENGTH_SHORT);
			return;
		}
		
		if (labelBll.hasExistSingleLabel(str, option_type)) {
			String tips = "本地已经存在未上传的调货标签：\n" + str;
			showIKnowTipsDialog(tips);
			return;
		}
		if (labels.size() == currentCargo.getExchange_count()) {
			String tips = "抱歉，本次调货列表已达到上限，请重新建立调货信息扫描";
			showIKnowTipsDialog(tips);
			return;
		}
//		LogUtil.d(TConfig.Echo, "option_type: " + option_type +"  option_id:"+option_id);
		labelBll.insertLabel(new SingleLabelOptionBean(str, option_type, option_id));
		labels = labelBll.queryAllLabelById(option_type, option_id);
		adapter.refreshData(labels);
		setLabelCountData();
	}

	private void showIKnowTipsDialog(String tips) {
		if (tipsDialog == null) {
			tipsDialog = new TipsDialog(context);
		}
		tipsDialog.show();
		tipsDialog.setWarnView("提示", tips, true, null);
	}
	
	private void showDelTipsDialog(final int position,String tipContent){
		if (tipsDialog == null) {
			tipsDialog = new TipsDialog(context);
		}
		tipsDialog.show();
		tipsDialog.setDelWarnView("提示", tipContent, position, false, new DSure() {
			
			@Override
			public void sureClick() {
				SingleLabelOptionBean b = labels.get(position);
				labelBll.deleteLabelByLabelId(b);
				labels = labelBll.queryAllLabelById(option_type, option_id);
				if (labels.size() == 0) {
//					activateBll.updateActivateNotSubmitStatusById(option_id);
					cargoBll.updateExchangeCargoStatusById(Config.SUBMIT_STATUS_NOT_SUBMIT, 0, option_id);
					setLabelStatusData();
				}
				adapter.refreshData(labels);
				setLabelCountData();
			}
		});
	}

	public SheepExCargoSingleLSPresenter(SingleLabelScannerConstact.View sView, Context context, Intent intent) {
		super(sView, context);
		this.sView = sView;
		this.context = context;
		currentCargo = (ExchangeCargoBean) intent.getSerializableExtra("currentCargoBean");
		option_id = currentCargo.getId();
		start();
	}

	@Override
	public void start() {
		if (!checkViewAvailable())
			return;
		init();
		View customView = LayoutInflater.from(context).inflate(R.layout.scanner_custom_diaplay_layout, null);
		initCustomView(customView);
		sView.setMoreOptionStr("上传");
		sView.setPageTitle("单标扫码");
		adapter = new SingleLabelAdapter(labels);
		sView.addHeadView(customView);
		sView.setAdapter(adapter);
		labels = labelBll.queryAllLabelById(option_type,
				currentCargo.getId());
		adapter.refreshData(labels);
		DealerBean fromDealer = dealerBll.queryDealerById(currentCargo.getFrom_dealer_id());
		DealerBean toDealer = dealerBll.queryDealerById(currentCargo.getTo_dealer_id());
		tv_scanner_text_identify1.setText("调货来源：" + fromDealer.getName());
		tv_scanner_text_identify2.setText("调到商家：" + toDealer.getName());
		setLabelCountData();
		setLabelStatusData();
	}

	private void setLabelCountData() {
		tv_scanner_text_identify3.setText("标签数量：" + labels.size()+" / " + currentCargo.getExchange_count());
	}

	private void setLabelStatusData() {
		if (currentCargo.getStatus() == Config.SUBMIT_STATUS_NOT_SUBMIT) {
			tv_scanner_text_identify4.setText("状态：未提交");
		} else {
			tv_scanner_text_identify4.setText("状态：提交失败  错误码：" + currentCargo.getError_code() +"\n原因："+ ThreadReqTools.getErrorMsg(currentCargo.getError_code()) );
		}
	}

	private void initCustomView(View v) {
		tv_scanner_text_identify1 = (TextView) v.findViewById(R.id.tv_scanner_text_identify1);
		tv_scanner_text_identify2 = (TextView) v.findViewById(R.id.tv_scanner_text_identify2);
		tv_scanner_text_identify3 = (TextView) v.findViewById(R.id.tv_scanner_text_identify3);
		tv_scanner_text_identify4 = (TextView) v.findViewById(R.id.tv_scanner_text_identify4);
	}

	private void init() {
		labelBll = new SingleLabelBll(context);
		dealerBll = new SheepDealerBll(context);
		cargoBll = new ExchangeCargoBll(context);
		configBll = new ConfigBll(context);
	}

	@Override
	public boolean checkViewAvailable() {
		boolean b = false;
		if (sView != null && context != null) {
			b = true;
		}
		return b;
	}

	@Override
	public Handler getHandler() {
		return mHandler;
	}

	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onResume() {
		// TODO Auto-generated method stub

	}

	@Override
	public void backClick() {
		// TODO Auto-generated method stub

	}

	@Override
	public void btnScannerClick() {
		if (!checkViewAvailable())
			return;
		sView.readQRCode();
	}

	@Override
	public void uploadClick() {
		if (!checkViewAvailable()) return;
		ConfigBean configBean = configBll.queryConfigByHandsetMode(currentHansetVersion);
		if (configBean == null) {
			sView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
			return;
		}
		if (labels.size() != currentCargo.getExchange_count()){
			sView.showMsgToast("当前的调货单还没有达到设置的数量，不能上传", Toast.LENGTH_SHORT);
			return;
		}
		
		if (!NetWorkUtils.isNetworkConnected(context)) {
			DialogUtils.showSetNetDialog(context);
			return;
		}
		
		showProgressDialog("提示", "正在提交调货信息，请稍后……");
		long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(configBean.getDeviceId()));
		ThreadPoolManager.getThreadPool().execute(new SheepExSubmitCargo(mHandler, deviceId, cargoBll, currentCargo, getLabels(labels), null));
	}
	
	private List<String> getLabels(List<SingleLabelOptionBean> labels2) {
		List<String> list = new ArrayList<>();
		for (SingleLabelOptionBean b : labels2) {
			list.add(b.getLabel_id());
		}
		return list;
	}

	public void dismissProgress() {
		if (bProgressDialog != null) {
			try {
				DialogUtils.dismissProgressDialog(bProgressDialog);
			} catch (Exception e) {
			}
		}
	}

	/**
	 * 提示正在更新数据
	 */
	protected void showProgressDialog(String titleStr, String tipsMsg) {
		bProgressDialog = DialogUtils.showProgressDialog(bProgressDialog, titleStr,
				tipsMsg, context);
	}

	@Override
	public void onItemClickLinstener(int position) {
//		int currentPos = labels.size() - position - 1;
		if (position > 0) {
			SingleLabelOptionBean b = labels.get(position - 1);
			String tipsContent = "确认删除调货标签：\n" + b.getLabel_id();
			showDelTipsDialog(position -1,tipsContent);
		}
		
	}

	@Override
	public void onItemLongClickListener(int position) {
		

	}

}
